//
// Mining module for TETDM
// RApplication.java Version 0.39
// Copyright(C) 2011 WATARU SUNAYAMA All RIGHTS RESERVED.
// This program is provided under the license.
// You Should read the README file.
//

package module.MiningModules.RApplication;

import source.*;
import source.TextData.*;

import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class RApplication extends MiningModule implements ActionListener
{
	String checkedText;

	String titles[];


	int buttonNumber;
	int mining[][], visual[][], size[][];
	ButtonGroup buttonGroup;

	public RApplication()
    {
		setModuleID(59999);
		setCategoryID(9);
		pairingVisualizationID = new int[]{3};
	}

	void panelDataCreation(int m[], int v[], int s[], int number)
	{
		mining[number] = m;
		visual[number] = v;
		size[number] = s;
	}

	public void initializePanel()
	{
        //        buttonNumber = 8;
        buttonNumber = 5;
        
        operationPanel.setBackground(Color.GREEN);
        operationPanel.setLayout(new GridLayout(buttonNumber,1));

		toggleButton = new JToggleButton[buttonNumber];
		mining = new int[buttonNumber][];
		visual = new int[buttonNumber][];
		size = new int[buttonNumber][];


        // DM -> TM
        int m0[] = {59999,50010,50000,3};
        int v0[] = {3,24,24,2};
        int s0[] = {1,3,3,3};
        
        // DM -> TM
        int m1[] = {59999,50010,50000,11,11,3};
        int v1[] = {3,24,24,8,1,2};
        int s1[] = {1,3,3,2,2,2};
        
        // TM -> DM
        int m2[] = {59999,50010,50000,26,3};
        int v2[] = {3,24,24,3,2};
        int s2[] = {1,3,3,3,3};
        
        // TM -> DM
        int m3[] = {59999,50010,50000,6,3};
        int v3[] = {3,24,24,9,2};
        int s3[] = {1,3,3,3,3};
        
        //TM -> DM
        int m4[] = {59999,50010,50000,35,3};
        int v4[] = {3,24,24,24,2};
        int s4[] = {1,3,3,3,3};


        /*
         3 -> 30003 wordExtraction2
         */
        

		int m5[] = {59999};
		int v5[] = {3};
		int s5[] = {1};

		// set6
		int m6[] = {59999};
		int v6[] = {3};
		int s6[] = {1};

		// set7
		int m7[] = {59999};
		int v7[] = {3};
		int s7[] = {1};
		// set4

		panelDataCreation(m0,v0,s0,0);
		panelDataCreation(m1,v1,s1,1);
		panelDataCreation(m2,v2,s2,2);
		panelDataCreation(m3,v3,s3,3);
		panelDataCreation(m4,v4,s4,4);
//		panelDataCreation(m5,v5,s5,5);
	//	panelDataCreation(m6,v6,s6,6);
		//panelDataCreation(m7,v7,s7,7);

		inJapanese = fileReadArray();

		String buttonNames[] = {"Editor","Sumamry","Light","Subject","Liver","WordExt","LongSent","Impolite"};

		if(isMenuInJapanese())
			for(int i=0;i<buttonNumber;i++)
				buttonNames[i] = inJapanese[23+i];

		buttonGroup = new ButtonGroup();

		for(int i=0;i<buttonNumber;i++)
		{
			toggleButton[i] = new JToggleButton(buttonNames[i]);
			toggleButton[i].setBackground(Color.green);
			toggleButton[i].addActionListener(this);
			operationPanel.add(toggleButton[i]);
			buttonGroup.add(toggleButton[i]);
		}
		int focus = getMainFocusInteger();
		if(focus >= 0 && focus < buttonNumber)
			toggleButton[focus].setSelected(true);


	}

	public void initializeData()
	{

	    String titleLists[] = {"Items","Results","Segments","Sentences","Subjects","Key Sentence","Lighting Rate","Coherence Rate",
							"Word Expression","Long Sentences","Total Score","Text","pts.","Keywords","Main Character","Subject Rate","Overlap Rate",
							"Structure","Expression","Wordy Sentences","Impolite Rate","Kanji Rate","Character Number"};

		if(isMenuInJapanese())
			titles = inJapanese;
		else
			titles = titleLists;
	}

	public void miningOperations(int optionNumber)
	{
		switch(optionNumber)
		{
			case 4502:
			case 0:
				checkedText = check_text();
				resetData();
				setDataString(checkedText);
				break;

			case 1:
				displayOperations(0);
				break;
		}
	}
    public String check_text()
	{
		StringWriter sw1 = new StringWriter();
		BufferedWriter bw1 = new BufferedWriter(sw1);

        int keywordCount=0;
        for(int i=0;i<text.keywordNumber;i++)
            if(text.keyword[i].frequency > 0)
                keywordCount++;

		try
		{
			//header
			bw1.write("<HTML><HEAD><TITLE>ANALYSIS</TITLE></HEAD><BODY>");
			bw1.write("<H1>"+titles[11]+" ["+(new File(text.sourceFilename).getName())+"] </H1>");

			//BASIC TABLE
			bw1.write("<H1>"+titles[0]+"</H1>");
			bw1.write("<TABLE BORDER=2 BORDERCOLOR=black>");

			bw1.write("<H3>"+titles[1]+"</H3>");
			bw1.write("<TABLE BORDER=2 BORDERCOLOR=black>");

			bw1.write("<TR>");
			bw1.write("<TD ALIGN=center>"+titles[22]+"</TD>");
			bw1.write("<TD ALIGN=center>"+text.textLength+"</TD>");
			bw1.write("</TR>");

			bw1.write("<TR>");
			bw1.write("<TD ALIGN=center>"+titles[2]+"</TD>");
			bw1.write("<TD ALIGN=center>"+text.segmentNumber+"</TD>");
			bw1.write("</TR>");

			bw1.write("<TR>");
			bw1.write("<TD ALIGN=center>"+titles[3]+"</TD>");
			bw1.write("<TD ALIGN=center>"+text.sentenceNumber+"</TD>");
			bw1.write("</TR>");

			bw1.write("<TR>");
			bw1.write("<TD ALIGN=center>"+titles[13]+"</TD>");
			bw1.write("<TD ALIGN=center>"+keywordCount+"</TD>");
			bw1.write("</TR>");

			bw1.write("</TABLE>");
			bw1.write("</TABLE>");

			bw1.write("</BODY></HTML>");
			bw1.flush();
		}
		catch(Exception e){
			System.out.println("Error in RApplication");
            e.printStackTrace();
		}

		return sw1.toString();
	}

	//Action listener
	public void actionPerformed(ActionEvent e)
	{
		writeSelectionButtonLog(e);/////NEW LOG

		for(int i=0;i<buttonNumber;i++)
			if(e.getSource() == toggleButton[i])
			{
                setMainFocusInteger(i);
				panelSetFromModule(mining[i], visual[i], size[i]);
				return;
			}

	}
}


